<?php
//BambooBasic Core Library  [core.php]
//Copyright (c) 2012 Michael Denathorn
//This software is protected by copyright, and must not be distributed by any means other then what is outlined in your End User License Agreement (EULA)
//No warranty implied, use at your own risk.

function bam_isset($mVariable)
{
	return(isset($mVariable));
}

function bam_unset($mVariable)
{
	unset($mVariable);
}

function bam_arraycount($arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	
	return(count($arr));
}

function bam_arraysort($arr,$reversed = false)
{
	if (!isset($arr))
	{
		return(Null);
	}
	
	if($reversed == false)
	{
		if(sort($arr))
		{
			return($arr);
		}
		else
		{
			return(Null);
		}
	}
	else
	{
		if(rsort($arr))
		{
			return($arr);
		}
		else
		{
			return(Null);
		}
	}
}

function bam_arrayshuffle($arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	
	if(shuffle($arr))
	{
		return($arr);
	}
	else
	{
		return(Null);
	}
}

function bam_arrayrand($arr,$iElementAmount = 1)
{
	if (!isset($arr))
	{
		return(Null);
	}
	
	return(array_rand($arr,$iElementAmount));
}

function bam_arrayfirstelement(&$arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	
	return(reset($arr));
}

function bam_arraylastelement(&$arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	return(end($arr));
}

function bam_arraynextelement(&$arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	return(next($arr));
}

function bam_arraypreviouselement(&$arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	return(prev($arr));
}

function bam_arraycurrentelement(&$arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	return(current($arr));
}

function bam_arraypush(&$arr,$mValue)
{
	if (!isset($arr))
	{
		return(Null);
	}
	return(array_push($arr,$mValue));
}

function bam_arraypop(&$arr)
{
	if (!isset($arr))
	{
		return(Null);
	}
	return(array_pop($arr));
}

function bam_arrayslice($arr,$iLength = 1, $iOffset = 0)
{
	if (!isset($arr))
	{
		return(Null);
	}
	
	return(array_slice($arr,$iOffset,$iLength));
}

function bam_arraycombine($arrKeys, $arrValues)
{
	if (!isset($arrKeys) || !isset($arrValues))
	{
		return(Null);
	}
	
	return(array_combine($arrKeys, $arrValues));
}

function bam_getvartype($mVar)
{
	return(gettype($mVar));
}

function bam_isarray($mVar)
{
	return(is_array($mVar));
}

function bam_isbool($mVar)
{
	return(is_bool($mVar));
}

function bam_iscallable($mVar)
{
	return(is_callable($mVar));
}

function bam_isfloat($mVar)
{
	return(is_float($mVar));
}

function bam_isinteger($mVar)
{
	return(is_int($mVar));
}

function bam_isnull($mVar)
{
	return(is_null($mVar));
}

function bam_isnumeric($mVar)
{
	return(is_numeric($mVar));
}

function bam_isobject($mVar)
{
	return(is_object($mVar));
}

function bam_isresource($mVar)
{
	return(is_resource($mVar));
}

function bam_isscalar($mVar)
{
	return(is_scalar($mVar));
}
function bam_isstring($mVar)
{
	return(is_string($mVar));
}

function bam_vardump($mVar)
{
	var_dump($mVar);
}

function bam_sleep($iSeconds, $bFlushOutput = true)
{	
	if($bFlushOutput)
	{
		ob_start();
		ob_implicit_flush(true);
		$buffer = str_repeat(" ", 4096);
		echo $buffer;
		ob_flush();
	}
	return(sleep($iSeconds));
}

function bam_typeexists($sTypeName)
{
	$sTypeName = strtolower($sTypeName);
	return(class_exists($sTypeName));
}

function bam_getobjecttype($objObject)
{
	return(get_class($objObject));
}

function bam_ismethod($mObject,$sMethodName)
{
	$sMethodName = strtolower($sMethodName);
	return(method_exists($mObject,$sMethodName));
}

function bam_isproperty($mType,$sProperty)
{
	$sProperty = strtolower($sProperty);
	if(is_string($mType))
	{
		$mType = strtolower($mType);
	}
	return(property_exists($mType,$sProperty));
}

?>