<?php
//BambooBasic File System Library  [filesystem.php]
//Copyright (c) 2012 Michael Denathorn
//This software is protected by copyright, and must not be distributed by any means other then what is outlined in your End User License Agreement (EULA)
//No warranty implied, use at your own risk.

function bam_openfile($sFilename)
{
	return(fopen($sFilename,"r+"));
}

function bam_readfile($sFilename)
{
	return(fopen($sFilename,"r"));
}

function bam_writefile($sFilename)
{
	return(fopen($sFilename,"w"));
}

function bam_closefile($hStream)
{
	return(fclose($hStream));
}

function bam_filepos($hStream)
{
	return(ftell($hStream));
}

function bam_seekfile($hStream, $iOffset)
{
	return(fseek($hStream,$iOffset));
}

function bam_filetype($sFilename)
{
	//Check for a file
	if (is_file($sFilename) == true) {return (1);}
	//Check for directory
	if (is_dir($sFilename) == true) {return (2);}
	//Nothing there, return a zero
	return(0);
}

function bam_opendirectory($sPath)
{
	return(opendir($sPath));
}

function bam_closedirectory($hDirStream)
{
	return(closedir($hResource));
}

function bam_readdirectory($hDirStream)
{
	return(readdir($hResource));
}

function bam_currentdirectory()
{
	return(getcwd());
}

function bam_changedirectory($sDirectory)
{
	return(chdir($sDirectory));
}

function bam_createdirectory($sPath)
{
	return(mkdir($sPath,octdec(755),true));
}

function bam_deletedirectory($sDirectory)
{
	return(rmdir($sDirectory));
}

function bam_setmode($sfilename, $iMode)
{
	return(chmod($sfilename, octdec($iMode)));
}

function bam_filesize($sFilename)
{
	return(filesize($sFilename));
}

function bam_copyfile($sSource, $sDestination)
{
	return(copy($sSource,$sDestination));
}

function bam_movefile($sOldPath, $sNewPath)
{
	return(rename($sOldPath,$sNewPath));
}

function bam_moveuploadedfile($sFilename, $sDestination)
{
	return(move_uploaded_file($sFilename,$sDestination));
}

function bam_deletefile($sFilename)
{
	return(unlink($sFilename));
}

function bam_readline($hStream)
{
	$line = fgets($hStream);
	$line = str_replace("\r","",$line);
	$line = str_replace("\n","",$line);
	return($line);
}

function bam_writeline($hStream,$sString,$sNewLine = "\r\n")
{
	return(fwrite($hStream, $sString.$sNewLine));
}

function bam_eof($hStream)
{
	return(feof($hStream));
}

function bam_basename($sPath,$sSuffix = "")
{
	return(basename($sPath,$sSuffix).PHP_EOL);
}

function bam_imagefiledimensions($sFilename)
{
	return(getimagesize($sFilename));
}
?>