<?php
//BambooBasic HTTP Library  [http.php]
//Copyright (c) 2012 Michael Denathorn
//This software is protected by copyright, and must not be distributed by any means other then what is outlined in your End User License Agreement (EULA)
//No warranty implied, use at your own risk.

function bam_serverglobal($sString)
{
	if(isset($_SERVER[$sString]))
	{
		return($_SERVER[$sString]);
	}
	
	return(null);
} 

function bam_getglobal($sString, $SQLLink = null)
{
	if(isset($_GET[$sString]))
	{
		
		if($SQLLink != null)
		{
			$getData = $_GET[$sString];
			$getData = trim($getData);
			$getData = htmlspecialchars($getData);
			$getData = mysqli_real_escape_string($SQLLink,$getData);
			return($getData);
		}
		else
		{
			
			return($_GET[$sString]);
		}
	}
	
	return(null);
} 

function bam_postglobal($sString, $SQLLink = null)
{
	if(isset($_POST[$sString]))
	{
		if($SQLLink != null)
		{
			$postData = $_POST[$sString];
			$postData = trim($postData);
			$postData = htmlspecialchars($postData);
			$postData = mysqli_real_escape_string($SQLLink,$postData);
			return($postData);
		}
		else
		{
			return($_POST[$sString]);
		}
	}
	
	return(null);
} 

function bam_filesglobal($sUserFile,$sAttribute)
{
	if(isset($_FILES[$sUserFile][$sAttribute]))
	{
		return($_FILES[$sUserFile][$sAttribute]);
	}
	
	return(null);
}

function bam_cookieglobal($sString)
{
	if(isset($_COOKIE[$sString]))
	{
		return($_COOKIE[$sString]);
	}
	
	return(null);
}

function bam_getsessionglobal($sString)
{
	if(isset($_SESSION[$sString]))
	{
		return($_SESSION[$sString]);
	}
	
	return(null);
}

function bam_setsessionglobal($sString,$data)
{
	$_SESSION[$sString] = $data;
}

function bam_removesessionglobal($sString)
{
	if(isset($_SESSION[$sString]))
	{
		unset($_SESSION[$sString]);
	}
}

function bam_httpheader($sString)
{
	header($sString);
}

function bam_sessionstart()
{
	session_start();
}

function bam_sessiondestroy()
{
	return(session_destroy());
}

function bam_setsessionname($sName)
{
	return(session_name($sName));
}

function bam_getsessionname()
{
	return(session_name());
}

function bam_sessionstatus()
{
	return(session_status());
}

function bam_sessionid()
{
	return(session_id());
}

function bam_setcookie($sName, $sValue, $iExpire = 0, $sPath = "/")
{
	return(setcookie($sName,$sValue,time() + $iExpire,$sPath));
}

function bam_sendemail($sTo, $sSubject, $sMessage, $sHeaders = "")
{
	return(mail($sTo, $sSubject, $sMessage,$sHeaders));
}
?>