<?php
//BambooBasic XML Library  [xml.php]
//Copyright (c) 2012 Michael Denathorn
//This software is protected by copyright, and must not be distributed by any means other then what is outlined in your End User License Agreement (EULA)
//No warranty implied, use at your own risk.

//Returns a empty XML document (Really, it's a DOM Document)
function bam_xmlnewxml($sVersion = "1.0", $sEncoding = "utf-8")
{
	return(new DOMDocument($sVersion, $sEncoding));
}

//Loads in a new XML document from a string
function bam_xmlloadxml($xmlString,$bValidate = false)
{
	$newXML = new DOMDocument("1.0","utf-8");
	$newXML->validateOnParse = $bValidate;
	$newXML->loadXML($xmlString);
	return($newXML);
}

//Save an XML document as a string
function bam_xmlsavexml($xmlResource)
{
	return($xmlResource->saveXML());
}

function bam_xmlprintxml($xmlString)
{
	echo htmlentities($xmlString);
}

//Returns a DOM element
function bam_xmlcreateelement($xmlResource, $sElement, $sValue = "")
{
	return($xmlResource->CreateElement($sElement,$sValue));
}

function bam_xmlcreateelementnode($sName,$sValue = "")
{
	return(new DOMElement($sName, $sValue));
}

function bam_xmlcreateattribute($xmlResource, $sName)
{
	return($xmlResource->createAttribute($sName));
}

function bam_xmlcreateattributenode($sName, $sValue = "")
{
	return(new DOMAttr($sName, $sValue));
}

function bam_xmlcreatetext($xmlResource, $sContent)
{
	return($xmlResource->createTextNode($sContent));
}

function bam_xmlcreatetextnode($sContent)
{
	return(new DOMText($sContent));
}

function bam_xmlappendchild($xmlResource, $xmlAdditionalNode)
{
	return($xmlResource->AppendChild($xmlAdditionalNode));
}

//Returns a list of nodes from the element tree that matches the past name.
function bam_xmlgetelementsbytagname($xmlResource, $sName)
{
	return($xmlResource->getElementsByTagName($sName));
}

function bam_xmlgetnodelistlength($xmlNodeList)
{
	return($xmlNodeList->length);
}

function bam_xmlgetlistnode($xmlNodeList,$iIndex)
{
	return($xmlNodeList->item($iIndex));
}

function bam_xmlgetnodetype($xmlNode)
{
	return($xmlNode->nodeType);
}

function bam_xmlgetnodetagname($xmlNode)
{
	return($xmlNode->tagName);
}

function bam_xmlgetnodevalue($xmlNode)
{
	return($xmlNode->nodeValue);
}
function bam_xmlsetnodevalue(&$xmlNode,$sValue)
{
	$xmlNode->nodeValue = $sValue;
}

function bam_xmlgetvalueastextnode($xmlNode)
{
	return(new DOMText($xmlNode->nodeValue));
}

function bam_xmlcopynode($xmlNode, $bDeepCopy = False)
{
	return($xmlNode->cloneNode($bDeepCopy));
}

function bam_xmlgetchildnodes($xmlNode)
{
	//This seems a terrible way of removing the first child from a list,
	//if we didnt, the child list would start from the childrens parent.. Will have
	//to watch that
	$childrenList = $xmlNode->childNodes;
	$firstChild = $childrenList->item(0);
	$xmlNode->removeChild($firstChild);
	$childrenList = $xmlNode->childNodes;
	return($childrenList);
}

function bam_xmlremovechild(&$xmlNode,$xmlChildNode)
{
	return($xmlNode->removeChild($xmlChildNode));
}

function bam_xmlreplacechild(&$xmlNode,$xmlNewNode,$xmlOldNode)
{
	return($xmlNode->replaceChild($xmlNewNode,$xmlOldNode));
}

function bam_xmlinsertchild(&$xmlNode, $xmlAdditionalNode, $refNode)
{
	return($xmlNode->insertBefore($xmlAdditionalNode,$refNode));
}

function bam_xmlgetattribute($xmlResource,$sName)
{
	return($xmlResource->getAttribute($sName));
}

function bam_xmlgetattributenode($xmlResource,$sName)
{
	return($xmlResource->getAttributeNode($sName));
}

function bam_xmlsetattribute(&$xmlResource,$sName,$sValue)
{
	return($xmlResource->setAttribute($sName,$sValue));
}

function bam_xmlsetattributenode(&$xmlResource,$xmlAttributeNode)
{
	return($xmlResource->setAttributeNode($xmlAttributeNode));
}

function bam_xmlremoveattribute(&$xmlResource,$sName)
{
	return($xmlResource->removeAttribute($sName));
}

function bam_xmlremoveattributenode(&$xmlResource,$xmlAttributeNode)
{
	return($xmlResource->removeAttributeNode($xmlAttributeNode));
}

function bam_xmlgetattributenodename($xmlAttributeNode)
{
	return($xmlAttributeNode->name);
}

function bam_xmlgetattributenodevalue($xmlAttributeNode)
{
	return($xmlAttributeNode->value);
}

function bam_xmlsetattributenodevalue(&$xmlAttributeNode,$sValue)
{
	$xmlAttributeNode->value = $sValue;
}

function bam_xmlgettextnodetext($xmlTextNode)
{
	return($xmlTextNode->data);
}

function bam_xmlsettextnodetext(&$xmlTextNode,$sValue)
{
	$xmlTextNode->data = $sValue;
}

function bam_xmltextnodelength(&$xmlTextNode)
{
	return($xmlTextNode->length);
}

function bam_xmltextnodeappenddata(&$xmlTextNode,$sData)
{
	$xmlTextNode->appendData($sData);
}

function bam_xmltextnodedeletedata(&$xmlTextNode,$iOffset, $iCount)
{
	$xmlTextNode->deleteData($iOffset, $iCount);
}

function bam_xmltextnodeinsertdata(&$xmlTextNode,$iOffset, $sData)
{
	$xmlTextNode->insertData($iOffset, $sData);
}

function bam_xmltextnodereplacedata(&$xmlTextNode,$iOffset, $iCount, $sData)
{
	$xmlTextNode->replaceData($iOffset, $iCount, $sData);
}

function bam_xmltextnodesubstring(&$xmlTextNode,$iOffset, $iCount)
{
	return($xmlTextNode->substringData($iOffset, $iCount));
}

?>